/*
Authorization Service API v. 1.0

<a href='https://cern.service-now.com/service-portal?id=privacy_policy&se=SSO-Service&notice=resources'>Privacy notice</a>

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package authzapiv1

import (
	"encoding/json"
	"fmt"
)

// ResourceState the model 'ResourceState'
type ResourceState string

// List of ResourceState
const (
	RESOURCESTATE_ACTIVE          ResourceState = "Active"
	RESOURCESTATE_ACTION_REQUIRED ResourceState = "ActionRequired"
	RESOURCESTATE_GRACE_PERIOD    ResourceState = "GracePeriod"
	RESOURCESTATE_BLOCKED         ResourceState = "Blocked"
	RESOURCESTATE_ARCHIVED        ResourceState = "Archived"
	RESOURCESTATE_DELETED         ResourceState = "Deleted"
	RESOURCESTATE_INVALID         ResourceState = "Invalid"
	RESOURCESTATE_CREATED         ResourceState = "Created"
)

// All allowed values of ResourceState enum
var AllowedResourceStateEnumValues = []ResourceState{
	"Active",
	"ActionRequired",
	"GracePeriod",
	"Blocked",
	"Archived",
	"Deleted",
	"Invalid",
	"Created",
}

func (v *ResourceState) UnmarshalJSON(src []byte) error {
	var value string
	err := json.Unmarshal(src, &value)
	if err != nil {
		return err
	}
	enumTypeValue := ResourceState(value)
	for _, existing := range AllowedResourceStateEnumValues {
		if existing == enumTypeValue {
			*v = enumTypeValue
			return nil
		}
	}

	return fmt.Errorf("%+v is not a valid ResourceState", value)
}

// NewResourceStateFromValue returns a pointer to a valid ResourceState
// for the value passed as argument, or an error if the value passed is not allowed by the enum
func NewResourceStateFromValue(v string) (*ResourceState, error) {
	ev := ResourceState(v)
	if ev.IsValid() {
		return &ev, nil
	} else {
		return nil, fmt.Errorf("invalid value '%v' for ResourceState: valid values are %v", v, AllowedResourceStateEnumValues)
	}
}

// IsValid return true if the value is valid for the enum, false otherwise
func (v ResourceState) IsValid() bool {
	for _, existing := range AllowedResourceStateEnumValues {
		if existing == v {
			return true
		}
	}
	return false
}

// Ptr returns reference to ResourceState value
func (v ResourceState) Ptr() *ResourceState {
	return &v
}

type NullableResourceState struct {
	value *ResourceState
	isSet bool
}

func (v NullableResourceState) Get() *ResourceState {
	return v.value
}

func (v *NullableResourceState) Set(val *ResourceState) {
	v.value = val
	v.isSet = true
}

func (v NullableResourceState) IsSet() bool {
	return v.isSet
}

func (v *NullableResourceState) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableResourceState(val *ResourceState) *NullableResourceState {
	return &NullableResourceState{value: val, isSet: true}
}

func (v NullableResourceState) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableResourceState) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
